'''''''''''''''''''''''''
' GUI ---test---- 
' (c)2011 Nastase Eodor
' nastase.eodor@gmail.com
'''''''''''''''''''''''''
#include once "windows.bi"

type PObject     as TObject ptr
type PComponent  as TComponent ptr
type PControl    as TControl ptr
type PWinControl as TWinControl ptr

#define nil  cast(any ptr, -1)
#define void cast(any ptr, 0)

#define GetWinControl(__HWND__) cast(TWinControl ptr, cast(any ptr, GetWindowLong(__HWND__,GetClassLong(__HWND__,GCL_CBWNDEXTRA)-4)))

#define TObjectClass(__PTR__)     *cast(PObject, @__PTR__)
#define TComponentClass(__PTR__)  *cast(PObject, __PTR__)
#define TControlClass(__PTR__)    *cast(PObject, __PTR__)
#define TWinControlClass(__PTR__) *cast(PObject, __PTR__)

type TObject extends Object
    Name      as string
    ClassName as zstring*256
end type

type TMessage
    Handle as hwnd
    Msg    as uint
    wParam as wparam
    lParam as lparam
    Result as lresult
    Sender as TObject ptr
    Dc     as hdc
end type

type TComponent extends TObject
    private:
    FComponentCount as integer
    FComponents     as PComponent ptr
    FParent         as PComponent
    declare sub Add(value as PComponent)
    declare sub Insert(index as integer,value as PComponent)
    declare sub Remove(value as PComponent)
    protected:
    public:
    declare function HasParent as PComponent
    declare function IndexOf(value as PComponent) as integer
    declare constructor
    declare destructor
end type

sub TComponent.Add(value as PComponent)
    if IndexOf(value) = -1 then
        value->FParent = @this
        FComponentCount += 1
        FComponents = reallocate(FComponents,sizeof(PComponent)*FComponentCount)
        FComponents[FComponentCount-1] = value
    end if
end sub

sub TComponent.Insert(index as integer,value as PComponent)
    if IndexOf(value) = -1 then
       if (Index > -1) and (Index < FComponentCount) then
          FComponentCount += 1
          FComponents = reallocate(FComponents,sizeof(PComponent)*FComponentCount)
          for i as integer = FComponentCount to Index+1 step -1
              FComponents[i] = FComponents[i-1]
          next i
          FComponents[Index] = value
          value->FParent = @this
       end if 
    end if
end sub

sub TComponent.Remove(value as PComponent)
    dim as integer Index
    Index = IndexOf(value)
    if Index <> -1 then
       FComponentCount -= 1
       if Index < FComponentCount then
          for i as integer = Index to FComponentCount-1
              FComponents[i] = FComponents[i +1]
          next i                               
       end if
       FComponents = reallocate(FComponents,sizeof(PComponent)*FComponentCount)
       value->FParent = void
    end if
end sub

function TComponent.IndexOf(value as PComponent) as integer
    return -1
end function

function TComponent.HasParent as PComponent
    return FParent
end function

constructor TComponent
end constructor

destructor TComponent
    if FParent then
        FParent->Remove(@this)
    end if
    FComponentCount = 0
    FComponents = callocate(FComponentCount)
end destructor

type TControl extends TComponent
    private:
    FControlCount as integer
    FControls     as PControl ptr
    FText         as string
    FAlign        as integer
    FLeft         as integer
    FTop          as integer
    FWidth        as integer
    FHeight       as integer
    FClientWidth  as integer
    FClientHeight as integer
    FEnabled      as integer
    FVisible      as integer
    FClientRect   as Rect
    protected:
    FParent       as PWinControl
    PaintControl  as sub(Sender as PControl,byref Dc as hdc)
    declare sub Add(value as PControl)
    declare sub Remove(value as PControl)
    declare function HandleIsAllocated as hwnd 
    declare sub SetParent(value as PWinControl)
    declare sub Repaint
    declare sub Invalidate
    public:
    declare function HasParent as PWinControl
    declare property Align as integer
	declare property Align(value as integer)
    declare property Text as string
	declare property Text(value as string)
	declare property Left as integer
	declare property Left(value as integer)
	declare property Top as integer
	declare property Top(value as integer)
	declare property Width as integer
	declare property Width(value as integer)
	declare property Height as integer
	declare property Height(value as integer)
	declare property ClientWidth as integer
	declare property ClientWidth(value as integer)
	declare property ClientHeight as integer
	declare property ClientHeight(value as integer)
    declare property ClientRect as Rect
	declare property ClientRect(value as Rect)
	declare property Enabled as integer
	declare property Enabled(value as integer)
	declare property Visible as integer
	declare property Visible(value as integer)
	declare property Style as integer
	declare property Style(value as integer)
    declare sub Insert(index as integer,value as PControl)
    declare function IndexOf(value as PControl) as integer
    declare constructor
    declare destructor
end type

type TWinControl extends TControl
    private:
    FHandle  as hwnd
    FBrush   as hbrush
    FExStyle as integer
    FStyle   as integer
    protected:
    FParent  as PWinControl
    declare sub ProcessMessage(byref message as TMessage)
    declare sub SetParent(value as PWinControl)
    declare sub PaintControls(Dc as hdc)
    public:
    declare operator cast as any ptr
    declare property Style as integer
    declare property Style(value as integer)
    declare property ExStyle as integer
    declare property ExStyle(value as integer)
    declare property Handle as hwnd
    declare property Handle(value as hwnd)
    declare constructor
    declare destructor
end type

common shared as TWinControl ptr CreationData

'''TControl'''
sub TControl.Add(value as PControl)
    if IndexOf(value) = -1 then
        FControlCount += 1
        FControls = reallocate(FControls,sizeof(PControl)*FControlCount)
        FControls[FControlCount-1] = value
    end if
end sub

sub TControl.Insert(index as integer,value as PControl)
    if IndexOf(value) = -1 then
       if (Index > -1) and (Index < FControlCount) then
          FControlCount += 1
          FControls = reallocate(FControls,sizeof(PControl)*FControlCount)
          for i as integer = FControlCount to Index+1 step -1
              FControls[i] = FControls[i-1]
          next i
          FControls[Index] = value
        end if 
    end if
end sub

sub TControl.Remove(value as PControl)
    dim as integer Index
    Index = IndexOf(value)
    if Index <> -1 then
       FControlCount -= 1
       if Index < FControlCount then
          for i as integer = Index to FControlCount-1
              FControls[i] = FControls[i +1]
          next i                               
       end if
       FControls = reallocate(FControls,sizeof(PControl)*FControlCount)
    end if
end sub

function TControl.IndexOf(value as PControl) as integer
    for i as integer = 0 to FControlCount -1
        if FControls[i] = value then return i
    next i
    return -1
end function

property TControl.Align as integer
    return FAlign
end property

property TControl.Align(value as integer)
    FAlign = value
end property

property TControl.Text as string
    if HandleIsAllocated then
        dim as integer L = GetWindowTextLength(HandleIsAllocated)
        L = iif(L,L+1,L)
        FText = space(L)
        GetWindowText(HandleIsAllocated,FText,L)
    end if
    return FText
end property

property TControl.Text(value as string)
    FText = value
    if HandleIsAllocated then
        SetWindowText(HandleIsAllocated,value)
    else
        Repaint
    end if
end property

property TControl.Left as integer
    return FLeft
end property

property TControl.Left(value as integer)
    FLeft = value
    if HandleIsAllocated then MoveWindow(HandleIsAllocated,FLeft,FTop,FWidth,FHeight,true)
end property

property TControl.Top as integer
   return FTop
end property

property TControl.Top(value as integer)
    FTop = value
    if HandleIsAllocated then MoveWindow(HandleIsAllocated,FLeft,FTop,FWidth,FHeight,true)
end property

property TControl.Width as integer
    return FWidth
end property

property TControl.Width(value as integer)
    FWidth = value
    if HandleIsAllocated then MoveWindow(HandleIsAllocated,FLeft,FTop,FWidth,FHeight,true)
end property

property TControl.Height as integer
    return FHeight
end property

property TControl.Height(value as integer)
    FHeight = value
    if HandleIsAllocated then MoveWindow(HandleIsAllocated,FLeft,FTop,FWidth,FHeight,true)
end property

property TControl.ClientWidth as integer
    if HandleIsAllocated then
    	FClientWidth = ClientRect.Right
    endIf
    return FClientWidth
end property

property TControl.ClientWidth(value as integer)
end property

property TControl.ClientHeight as integer
    if HandleIsAllocated then
    	FClientHeight = ClientRect.Bottom
    endIf
    return FClientHeight 
end property

property TControl.ClientHeight(value as integer)
end property

property TControl.ClientRect as Rect
    if HandleIsAllocated then
    	GetClientRect(HandleIsAllocated,@FClientRect)
    endIf
    return FClientRect
end property

property TControl.ClientRect(value as Rect)
end property

property TControl.Enabled as integer
    return FEnabled
end property

property TControl.Enabled(value as integer)
    FEnabled = value
    if HandleIsAllocated then EnableWindow(HandleIsAllocated,FEnabled)
end property

property TControl.Visible as integer
    return FVisible
end property

property TControl.Visible(value as integer)
    FVisible = value
    if HandleIsAllocated then ShowWindow(HandleIsAllocated,iif(value,sw_show,sw_hide))
end property

function TControl.HasParent as PWinControl
    return FParent
end function

sub TControl.SetParent(value as PWinControl)
    dim as PWinControl SaveParent = FParent
    FParent = value
    if FParent then
        cast(PControl,FParent)->Add(@this)
        if value->Handle then
           InvalidateRect(value->Handle,@type(FLeft,FTop,FWidth,FHeight),true)
        end if
    end if
    if SaveParent then
        cast(PControl,SaveParent)->Remove(@this)
    end if
end sub

sub TControl.Repaint
    if not(this is TWinControl) then
       if FParent->Handle then
           RedrawWindow(FParent->Handle,@type(FLeft,FTop,FWidth,FHeight),0,RDW_INVALIDATE or RDW_ERASE)
           UpdateWindow(FParent->Handle)
       end if 
    else
       if HandleIsAllocated then 
           RedrawWindow(HandleIsAllocated,0,0,RDW_INVALIDATE or RDW_ERASE)
           UpdateWindow(HandleIsAllocated)
       end if
    end if
end sub

sub TControl.Invalidate
    if not(this is TWinControl) then
       if FParent->Handle then
           InvalidateRect(FParent->Handle,@type(FLeft,FTop,FWidth,FHeight),true)
       end if 
    else
       if HandleIsAllocated then 
           InvalidateRect(HandleIsAllocated,0,true)
       end if
    end if
end sub

function TControl.HandleIsAllocated as hwnd
    if cast(PWinControl,@this) then
        return cast(PWinControl,@this)->Handle
    end if
end function

constructor TControl
end constructor

destructor TControl
    FControlCount = 0
    FControls = callocate(FControlCount)
end destructor

'''TWinControl'''
operator TWinControl.cast as any ptr
    return cast(any ptr,@this) 
end operator

property TWinControl.Handle as hwnd
    return FHandle
end property

property TWinControl.Handle(value as hwnd)
end property

property TWinControl.ExStyle as integer
    if Handle then
        GetWindowLong(Handle,GWL_EXSTYLE)
    end if
    return FExStyle
end property

property TWinControl.ExStyle(value as integer)
    FExStyle = value
    if Handle then
       dim as integer Active = (GetActiveWindow=Handle)
       SetWindowLong(Handle,gwl_exstyle,FExStyle)
       SetWindowPos(Handle,0,0,0,0,0,iif(Active,0,swp_noactivate) or swp_nomove or swp_nosize or swp_nozorder or swp_noownerzorder or swp_framechanged or iif(FVisible,swp_showwindow,0))
       RedrawWindow(Handle,0,0,rdw_erase or rdw_invalidate)
    endIf
end property

property TWinControl.Style as integer
    if Handle then
        GetWindowLong(Handle,GWL_STYLE)
    end if
    return FStyle
end property

property TWinControl.Style(value as integer)
    FStyle = value
    if Handle then
       dim as integer Active = (GetActiveWindow=Handle) 
       SetWindowLong(Handle,gwl_style,FStyle)
       SetWindowPos(Handle,0,0,0,0,0,iif(Active,0,swp_noactivate) or swp_nomove or swp_nosize or swp_nozorder or swp_noownerzorder or swp_framechanged or iif(FVisible,swp_showwindow,0))
       RedrawWindow(Handle,0,0,rdw_erase or rdw_invalidate)
    endIf
end property

sub TWinControl.ProcessMessage(byref message as TMessage)
    FHandle = message.Handle
    select case message.Msg
    case WM_CREATE
        SetWindowLong(FHandle,GetClassLong(FHandle,GCL_CBWNDEXTRA)-4,cint(cast(any ptr,@this)))
        CreationData = cast(any ptr, 0)
        message.result = false
    case WM_DESTROY
        message.result = false
    case WM_PAINT
        message.dc = GetDc(message.Handle)
        PaintControls(message.Dc)
        ReleaseDc(message.Handle,message.Dc)
        message.Dc = 0
        message.result = false
    end select
end sub

sub TWinControl.PaintControls(Dc as hdc)
    for i as integer = 0 to FControlCount-1
        if not(*FControls[i] is TWinControl) then
            if FControls[i]->Visible then
               if FControls[i]->PaintControl<>0 then
                   FControls[i]->PaintControl(FControls[i],Dc)
               end if
            end if
        end if
    next i
end sub

sub TWinControl.SetParent(value as PWinControl)
    dim as PWinControl SaveParent = FParent
    FParent = value
    if FParent then
        cast(PControl,FParent)->Add(@this)
    end if
    if SaveParent then
        cast(PControl,SaveParent)->Remove(@this)
    end if
    if FHandle then
        .SetParent(FHandle,iif(FParent,FParent->FHandle,0))
    end if
end sub

constructor TWinControl
end constructor

destructor TWinControl
    if FBrush then
        DeleteObject(FBrush)
    end if
    if IsWindow(FHandle) then
        DestroyWindow(FHandle)
        FHandle = 0
    end if
    if FParent then
        FParent->Remove(@this)
    end if
end destructor

enum TFormStyle
    fsNormal    = 0
    fsMDIFrame
    fsMDIChild
    fsStayOnTop
end enum
    
type TForm extends TWinControl
    private:
    FClient     as TWinControl
    FColor      as integer
    FFormStyle  as integer
    protected:
    declare static function WindowProc(hDlg as hwnd,Msg as uint,wParam as wparam,lParam as lparam) as integer
    declare static function ClientWindowProc(hDlg as hwnd,Msg as uint,wParam as wparam,lParam as lparam) as integer
    declare sub ProcessMessage(byref message as TMessage)
    declare sub ClientDefaultHandler(byref message as TMessage)
    declare sub RegisterClass
    declare sub CreateHandle
    declare sub CreateClientHandle
    declare sub FreeClientHandle
    public:
    declare property Parent as PWinControl
    declare property Parent(value as PWinControl)
    declare property Color as integer
    declare property Color(value as integer) 
    declare property FormStyle as integer
    declare property FormStyle(value as integer) 
    declare operator cast as any ptr
    declare constructor(byref AClassName as string="TForm")
    declare destructor
    OnCreate as sub(byref Sender as TForm)
    OnClose  as sub(byref Sender as TForm,byref CloseAction as integer)
end type

function TForm.WindowProc(hDlg as hwnd,Msg as uint,wParam as wparam,lParam as lparam) as integer
    dim as TWinControl ptr WinControl = iif(CreationData, CreationData, GetWinControl(hDlg)) 
    dim as TMessage message = type(hDlg,Msg,wParam,lParam,0,WinControl)
    if WinControl then
       WinControl->ProcessMessage(message)
       cast(TForm ptr,WinControl)->ProcessMessage(message)
       return message.result
    end if
    return message.result
end function

function TForm.ClientWindowProc(hDlg as hwnd,Msg as uint,wParam as wparam,lParam as lparam) as integer
    dim as TWinControl ptr WinControl = iif(CreationData, CreationData, GetWinControl(hDlg)) 
    dim as TMessage message = type(hDlg,Msg,wParam,lParam,0,WinControl)
    if WinControl then
       WinControl->ProcessMessage(message)
       dim as WndClassEx wc
       wc.cbSize = sizeof(wc)
       if GetClassInfoEx(0,"MDIClIENT",@wc) then
          message.result = CallWindowProc(wc.lpfnWndProc,message.Handle,message.Msg,message.wParam,message.lParam)
       end if
       return message.result
    end if
    return message.result
end function

property TForm.Parent as PWinControl
    return cast(TWinControl, this).FParent
end property

property TForm.Parent(value as PWinControl)
    if FHandle = 0 then
       Base.SetParent(value)
       CreateHandle
    else
       Base.SetParent(value)
    end if
end property

property TForm.Color as integer
    if FBrush then
        dim as logbrush LB
        if GetObject(FBrush,sizeof(LB),@LB) then
            FColor = LB.lbColor
        end if
    end if
    return FColor
end property

property TForm.Color(value as integer)
    FColor = value
    if FBrush then DeleteObject(FBrush)
    FBrush = CreateSolidBrush(FColor)
    InvalidateRect(Handle,0,true)
end property

property TForm.FormStyle as integer
    return FFormStyle
end property

sub TForm.CreateClientHandle
    if FClient.Handle = 0 then
        CreationData = FClient
        dim as WndClassEx wc
        wc.cbSize = sizeof(wc)
        if GetClassInfoEx(0,"MDICLIENT",@wc)  then
            wc.lpszClassName = strptr("TMDIClient")
            wc.lpfnWndProc   = @ClientWindowProc
            wc.hInstance     = GetModuleHandle(0)
            wc.cbWndExtra    = wc.cbWndExtra + 4
            RegisterClassEx(@Wc)
        end if
        dim as ClientCreateStruct ccs
        ccs.idFirstChild = &H00FFF
        FClient.Width   = ClientWidth
        FClient.Height  = ClientHeight
        FClient.Enabled = 1
        FClient.Visible = 1
        CreateWindowEx(WS_EX_CLIENTEDGE,"TMDIClient","",WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL,0,0,FClientWidth,FClient.Height,Handle,cast(HMENU,&HCAC),GetModuleHandle(0),@ccs)
        FClient.SetParent(this)
        if FClient.Handle then
            EnableWindow(FClient.Handle,FEnabled)
            ShowWindow(FClient.Handle,iif(FVisible,SW_SHOW,SW_HIDE))
            UpdateWindow(FClient.Handle)
        end if
    end if
end sub

sub TForm.FreeClientHandle
    if FClient.Handle then
        DestroyWindow(FClient.Handle)
        FClient.Handle = 0
    end if
end sub

property TForm.FormStyle(value as integer) 
    FFormStyle = value
    if value = fsNormal then
        FreeClientHandle
    elseif value = fsMDIFrame then
        CreateClientHandle
    elseif value = fsMDIChild then
        FreeClientHandle
    end if    
end property

sub TForm.ProcessMessage(byref message as TMessage)
    if Message.Msg = WM_CREATE then
        Color = FColor 
        if OnCreate then
            OnCreate(this)
        end if
        Message.Result = false
    elseif Message.Msg = WM_CLOSE then
        dim as integer Action = 1
        if OnClose then
            OnClose(this,Action)
        end if
        if Action = 0 then
            Message.Result = true
            exit sub
        end if
    elseif Message.Msg = WM_ERASEBKGND then
        Dim as Rect R
        GetClientRect(FHandle,@R)
        FillRect(cast(hdc,Message.wParam),@R,FBrush)
        Message.Result = true
        exit sub
    elseif Message.Msg = WM_SIZE then
        if FormStyle = fsMDIFrame then
            message.result = true
            exit sub
        else
            message.result = false
        end if
    else
        message.result = false
    end if 
    if (FExStyle and WS_EX_MDICHILD) then
        message.result = DefMdiChildProc(message.Handle,message.Msg,message.wParam,message.lParam)
    elseif (FClient.Handle<>0) then
        message.result = DefFrameProc(message.Handle,FClient.Handle,message.Msg,message.wParam,message.lParam)
    else
        message.result = DefWindowProc(message.Handle,message.Msg,message.wParam,message.lParam)
    end if
end sub

sub TForm.RegisterClass
    dim as WndClassEx wc
    wc.cbSize = sizeof(wc)
    if GetClassInfoEx(GetModuleHandle(0),ClassName,@wc) = 0 then
         wc.lpszClassName = strptr(ClassName)
         wc.lpfnWndProc   = @WindowProc
         wc.hInstance     = GetModuleHandle(0)
         wc.hCursor       = LoadCursor(0,IDC_ARROW)
         wc.cbWndExtra    = wc.cbWndExtra + 4
         RegisterClassEx(@Wc)
    end if
end sub

sub TForm.CreateHandle
    CreationData = @this
    CreateWindowEx(FExStyle,ClassName,FText,FStyle or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,FLeft,FTop,FWidth,FHeight,iif(Parent,Parent->Handle,0),0,GetModuleHandle(0),0)
    if Handle then
        FormStyle = FFormStyle
        EnableWindow(FHandle,FEnabled)
        ShowWindow(FHandle,iif(FVisible,SW_SHOW,SW_HIDE))
        UpdateWindow(FHandle)
    end if
end sub

operator TForm.cast as any ptr
    return cast(any ptr,@this) 
end operator

constructor TForm(byref AClassName as string="TForm")
    ClassName = AClassName
    FStyle    = WS_OVERLAPPEDWINDOW
    FWidth    = 500
    FHeight   = 350
    FColor    = GetSysColor(COLOR_BTNFACE)
    FVisible  = 1
    FEnabled  = 1
    RegisterClass
end constructor

destructor TForm
end destructor

type TLabel extends TControl
    private:
    protected:
    declare static sub Paint(Sender as PControl,byref Dc as hdc)
    public:
    declare property Parent as PWinControl
    declare property Parent(value as PWinControl)
    declare constructor
    declare destructor
end type

sub TLabel.Paint(Sender as PControl,byref Dc as hdc)
    with *cast(TLabel ptr, Sender)
       TextOut(Dc,.FLeft,.FTop,.FText,Len(.FText))
    end with
end sub

property TLabel.Parent as PWinControl
    return Base.FParent
end property

property TLabel.Parent(value as PWinControl)
    Base.SetParent(value)
end property

constructor TLabel
    Base.PaintControl = @Paint
    FWidth   = 97
    FHeight  = 17
    FVisible = 1
    FEnabled = 1
    FText    = "Label"
end constructor

destructor TLabel
end destructor


''''MainCode''''
dim shared as TForm Form, Form1
dim shared as TLabel Label(10)

sub FormCreate(Sender as TForm)
    MessageBox(Sender.Handle,"I'm in create","TForm",0)
    Form1.Width   = 400
    Form1.Height  = 300
    Form1.Color   = &hffff
    Form1.ExStyle = WS_EX_DLGMODALFRAME
    Form1.Style   = WS_CAPTION or WS_SYSMENU
    Form1.Parent  = Form
end sub

sub FormClose(Sender as TForm,byref CloseAction as integer)
    if MessageBox(Sender.Handle,"Close ?","TForm",MB_YESNO or MB_ICONQUESTION)=IDNO then
        CloseAction=0
    else
        PostQuitMessage(0)
    end if    
end sub

Form.OnCreate  = @FormCreate
Form.OnClose   = @FormClose
Form.FormStyle = fsMDIFrame
Form.Parent    = 0

for i as integer = 0 to ubound(Label)-1
Label(i).Text = "Label" & i
Label(i).Left    = i*100
Label(i).Top     = 410
Label(i).Visible = 1
Label(i).Parent  = Form
next i

Form1.Text = "Form1"


dim as msg m
while GetMessage(@m,0,0,0)>0
    TranslateMessage(@m)
    DispatchMessage(@m)
wend

